// CalcProbDoc.cpp : CCalcProbDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "CalcProb.h"

#include "CalcProbDoc.h"
#include <vector>

int CCalcProbDoc::s_currentVersion = 102; // ݂̃o[W * 100

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCalcProbDoc

IMPLEMENT_DYNCREATE(CCalcProbDoc, CDocument)

BEGIN_MESSAGE_MAP(CCalcProbDoc, CDocument)
	//{{AFX_MSG_MAP(CCalcProbDoc)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalcProbDoc NX̍\z/

CCalcProbDoc::CCalcProbDoc()
{
	Clear();
}

CCalcProbDoc::~CCalcProbDoc()
{
}

int NSize(CGraph& grp)
{
	int res = 0;
	CGraph::node_iterator	nit;
	for (nit=grp.nbegin();nit!=grp.nend();++nit) {
		if (nit->IsNode()) ++res;
	}
	return res;
}

void CCalcProbDoc::Calc()
{
	CGraph&	grp = Graph();
	double	d;
	int		i,j,k, n = NSize(grp);
	CGraph::node_iterator	nit;
	CGraph::arc_iterator	ait;
	vector<double>	vi(grp.nsize()),vo(grp.nsize());
	ASSERT(grp.is_valid());
	i = 0;
	d = 1./_MAX(1,n);
	for (nit=grp.nbegin();nit!=grp.nend();++nit) {
		if (nit->m_type == CNode::Start) d = 0.;
		nit.temp() = i++;
		nit->m_ave = 0.;
	}
	for (nit=grp.nbegin();nit!=grp.nend();++nit)
		nit->m_val = nit->m_type == CNode::Start ? 1. : d;
	for (k=0;k<m_opt.m_iter;++k) {
		fill(vi.begin(),vi.end(),0.);
		fill(vo.begin(),vo.end(),0.);
		for (ait=grp.abegin();ait!=grp.aend();++ait) {
			i = ait.left().temp();
			j = ait.right().temp();
			ASSERT(i >= 0 && i < vo.size());
			ASSERT(j >= 0 && j < vi.size());
			d = ait->m_prob * ait.left()->m_val;
			vo[i] -= d;
			vi[j] += d;
		}
		for (i=0, nit=grp.nbegin();nit!=grp.nend();++nit, ++i) {
			d = vi[i] + vo[i];
			nit->m_val += d;
			nit->m_ave += d * (k+1);
		}
	}
	for (nit=grp.nbegin();nit!=grp.nend();++nit) {
		if (nit->m_ave > 0 && nit->m_val > 0)
			nit->m_ave /= nit->m_val;
	}
}

void CCalcProbDoc::ResetArc()
{
	CGraph&	grp = Graph();
	CGraph::arc_iterator	ait;
	for (ait=grp.abegin();ait!=grp.aend();++ait) {
		CArc&	ac = *ait;
		if (!ac.m_str.IsEmpty())
			ac.m_prob = DlgOption().m_dict[ac.m_str];
	}
}

void CCalcProbDoc::Clone(int i)
{
	list<CGraph>::iterator it = m_cur;
	m_data.erase(++it,m_data.end());
	if (i) m_data.insert(m_cur,*m_cur);
	while (m_data.size() > i+1)
		m_data.erase(m_data.begin());
}

void CCalcProbDoc::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_data.begin() != m_cur);
}

void CCalcProbDoc::OnUpdateEditRedo(CCmdUI* pCmdUI) 
{
	list<CGraph>::const_iterator it = m_data.end();
	if (!m_data.empty()) --it;
	pCmdUI->Enable(it != m_cur);
}

void CCalcProbDoc::OnEditUndo() 
{
	if (m_cur == m_data.begin())
		return;
	--m_cur;
	SetModifiedFlag();
	m_selN.clear();
	m_selA.clear();
	UpdateAllViews(0);
}

void CCalcProbDoc::OnEditRedo() 
{
	if (m_cur != m_data.end()) {
		if (++m_cur == m_data.end()) {
			--m_cur;
			return;
		}
	}
	SetModifiedFlag();
	m_selN.clear();
	m_selA.clear();
	UpdateAllViews(0);
}

/////////////////////////////////////////////////////////////////////////////
// CCalcProbDoc VAC[[V

void CCalcProbDoc::Serialize(CArchive& ar)
{
	CGraph&	grp = Graph();
	CGraph::node_iterator	nit;
	CGraph::arc_iterator	ait;
	int						i,n1,n2,nn,na;
	CRect					r;
	if (ar.IsStoring()) {
		AfxGetMainWnd()->GetWindowRect(&r);
		ar << s_currentVersion << m_rate << r;
		m_opt.Serialize(ar);
		ar << grp.nsize();
		for (i=0, nit=grp.nbegin();nit!=grp.nend();++nit, ++i) {
			nit->Serialize(ar,m_ver);
			nit.temp() = i;
		}
		ar << grp.asize();
		for (ait=grp.abegin();ait!=grp.aend();++ait) {
			ait->Serialize(ar,m_ver);
			ar << ait.left().temp() << ait.right().temp();
		}
	} else {
		ar >> m_ver >> m_rate >> r;
		POSITION pos = GetFirstViewPosition();
		GetNextView(pos)->GetParentFrame()->SetWindowPos(
			0,0,0,r.Width(),r.Height(),SWP_NOMOVE | SWP_NOZORDER);
		m_opt.Serialize(ar);
		ar >> nn;
		vector<CGraph::node_iterator>	v(nn);
		CArc	ac;
		CNode	nd(CPoint(0,0),"");
		grp.clear();
		for (i=0;i<nn;++i) {
			nd.Serialize(ar,m_ver);
			v[i] = grp.add_node(nd);
		}
		ar >> na;
		for (i=0;i<na;++i) {
			ac.Serialize(ar,m_ver);
			ar >> n1 >> n2;
			grp.add_arc(ac,v[n1],v[n2]);
		}
		Calc();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCalcProbDoc NX̐ff

#ifdef _DEBUG
void CCalcProbDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCalcProbDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCalcProbDoc R}h

CSize CCalcProbDoc::DocSize()
{
	return CSize(m_opt.m_width,m_opt.m_height);
}

CSize CCalcProbDoc::ViewSize()
{
	CSize	sz = DocSize();
	return CSize(int(sz.cx * m_rate),int(sz.cy * m_rate));
}

void CCalcProbDoc::SetBkBitmap()
{
	HBITMAP hb = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
		DlgOption().m_bkPict,IMAGE_BITMAP,0,0,LR_LOADFROMFILE | LR_CREATEDIBSECTION);
	GetBkBitmap().Detach();
	if (hb) GetBkBitmap().Attach(hb);
}

// OtɕύX
void CCalcProbDoc::SetModify(bool bCalc /* ČvZ */)
{
	if (bCalc) {
		Calc();
	}
	SetModifiedFlag();
	UpdateAllViews(0);
}

void CCalcProbDoc::DeleteContents() 
{
	CGraph&	grp = Graph();
	m_opt.Reset();
	m_rate = 1.0;
	Clear();
	CFrameWnd*	pWnd = (CFrameWnd*)AfxGetMainWnd();
	if (pWnd) pWnd->InitialUpdateFrame(this,TRUE);
	CDocument::DeleteContents();
}
