// CalcProbView.cpp : CCalcProbView NX̓̒`s܂B
//

#include "stdafx.h"
#include "CalcProb.h"

#include "CalcProbDoc.h"
#include "CalcProbView.h"
#include "DlgGetStr.h"
#include "DlgInfoNode.h"
#include "DlgInfoArc.h"
#include <cmath>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCalcProbView

inline int Abs(const CSize& p)
	{return max(abs(p.cx),abs(p.cy));}

IMPLEMENT_DYNCREATE(CCalcProbView, CScrollView)

BEGIN_MESSAGE_MAP(CCalcProbView, CScrollView)
	//{{AFX_MSG_MAP(CCalcProbView)
	ON_COMMAND(ID_VIEW_OPTION, OnViewOption)
	ON_UPDATE_COMMAND_UI(ID_EDIT_MAKE, OnUpdateEditMake)
	ON_COMMAND(ID_EDIT_MAKE, OnEditMake)
	ON_WM_LBUTTONDOWN()
	ON_WM_SETCURSOR()
	ON_COMMAND(ID_VIEW_ZOOMUP, OnViewZoomup)
	ON_COMMAND(ID_VIEW_ZOOMDOWN, OnViewZoomdown)
	ON_COMMAND(ID_VIEW_ZOOMANY, OnViewZoomany)
	ON_UPDATE_COMMAND_UI(ID_EDIT_MAKEA, OnUpdateEditMakea)
	ON_COMMAND(ID_EDIT_MAKEA, OnEditMakea)
	ON_UPDATE_COMMAND_UI(ID_EDIT_MAKEN, OnUpdateEditMaken)
	ON_COMMAND(ID_EDIT_MAKEN, OnEditMaken)
	ON_COMMAND(ID_EDIT_MAKENEXT, OnEditMakenext)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_WM_SIZE()
	ON_COMMAND(ID_EDIT_MAKEC, OnEditMakec)
	ON_UPDATE_COMMAND_UI(ID_EDIT_MAKEC, OnUpdateEditMakec)
	ON_COMMAND(ID_HELP, OnHelp)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalcProbView NX̍\z/

CCalcProbView::CCalcProbView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
}

CCalcProbView::~CCalcProbView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CCalcProbView NX̕`

void DrawLine(CDC* pDC,const CPoint& p1,const CPoint& p2)
{
	pDC->MoveTo(p1);
	pDC->LineTo(p2);
}

void DrawRect(CDC* pDC,const CRect& r)
{
	pDC->MoveTo(r.left,r.top);
	pDC->LineTo(r.left,r.bottom);
	pDC->LineTo(r.right,r.bottom);
	pDC->LineTo(r.right,r.top);
	pDC->LineTo(r.left,r.top);
}

void DrawArrow(CDC* pDC,int sx,int sy,int tx,int ty,int siz)
{
	int		x = tx - sx, y = ty - sy;
	double	dx,dy,rx,ry, c = 0.4, r = sqrt(double(x)*x + double (y)*y);
	pDC->MoveTo(sx,sy);
	pDC->LineTo(tx,ty);
	if (siz <= 0 || r < siz) return;
	r = siz / r;
	dx = rx = r*x;
	dy = ry = r*y;
	rx *= c;
	ry *= c;
	pDC->BeginPath();
	pDC->LineTo(int(tx-dx-ry),int(ty-dy+rx));
	pDC->LineTo(int(tx-dx+ry),int(ty-dy-rx));
	pDC->EndPath();

	CBrush* pbr = (CBrush*)pDC->SelectStockObject(BLACK_BRUSH);
	pDC->FillPath();
	pDC->SelectObject(pbr);
}

/*
class CBufDC {
	CBitmap		bm;
	CBitmap*	pBmOld;
	CDC			dcMem;
	CDC*		pDC0;
	CRect		rct;
	CBufDC(const CBufDC&);
public:
	CBufDC(CView* pView,CDC* pDCorg) : pDC0(pDCorg) {
		pView->GetClientRect(&rct);
		dcMem.CreateCompatibleDC(pDC0);
		bm.CreateCompatibleBitmap(pDC0,rct.Width(),rct.Height());
		pBmOld = dcMem.SelectObject(&bm);
		dcMem.FillSolidRect(&rct,pDC0->GetBkColor());
		pView->OnPrepareDC(&dcMem,0);
	}
	~CBufDC() {
		pDC0->BitBlt(0,0,rct.Width(),rct.Height(),&dcMem,0,0,SRCCOPY);
		dcMem.SelectObject(pBmOld);
	}
	CDC* GetDC(){return &dcMem;}
};
	CBufDC	dc(this,pDC0);	// CBufDC gpȂꍇ́A 2s
	CDC* pDC = dc.GetDC();	// āApDC0  pDC ɖ߂AOnEraseBkgnd ߂
// */

void CCalcProbView::OnDraw(CDC* pDC)
{
	CCalcProbDoc* pDoc = GetDocument();
	CGraph&	grp = pDoc->Graph();
	if (pDoc->GetBkBitmap().m_hObject) {
		BITMAP	bmp;
		pDoc->GetBkBitmap().GetBitmap(&bmp);
		CDC		mdc;
		mdc.CreateCompatibleDC(pDC);
		CBitmap*	pbmOld = mdc.SelectObject(&pDoc->GetBkBitmap());
		pDC->BitBlt(0,0,bmp.bmWidth,bmp.bmHeight,&mdc,0,0,SRCCOPY);
		mdc.SelectObject(pbmOld);
	}
	CGraph::node_iterator	nit;
	for (nit=grp.nbegin();nit!=grp.nend();++nit) {
		nit->Draw(pDC,pDoc->DlgOption().m_bShowNode != 0);
	}
	CGraph::arc_iterator	ait;
	for (ait=grp.abegin();ait!=grp.aend();++ait) {
		ait->Draw(pDC,ait.left()->m_pos,ait.right()->m_pos,
			pDoc->DlgOption().m_bShowArc != 0);
	}
	// I
	CPen	pen(PS_SOLID,0,RGB(128,128,128)),*pOldp = pDC->SelectObject(&pen);
	CSelNode::iterator	snit;
	for (snit=pDoc->SelNode().begin();snit!=pDoc->SelNode().end();++snit) {
		(*snit)->DrawSel(pDC);
	}
	CSelArc::iterator	sait;
	for (sait=pDoc->SelArc().begin();sait!=pDoc->SelArc().end();++sait) {
		ait = *sait;
		ait->DrawSel(pDC,ait.left()->m_pos,ait.right()->m_pos);
	}
	pDC->SelectObject(pOldp);
	// Xe[^Xo[֕\
	CString	s,t;
	if (pDoc->SelNode().size() == 1) {
		CNode& nd = **pDoc->SelNode().begin();
		if (nd.m_type != CNode::Comment) {
			if (nd.m_ave < 0) t = "--";
			else t.Format("%g",nd.m_ave);
			s.Format(" %s  m %g   ",
				(const char*)nd.m_name,nd.m_val);
			s += t;
		}
	} else if (pDoc->SelArc().size() == 1) {
		CArc& ac = **pDoc->SelArc().begin();
		s.Format("Jڊm %g",ac.m_prob);
		if (!ac.m_str.IsEmpty())
			s += " (" + ac.m_str + ")";
	} else {
		s.Format("Ԑ %d  Jڐ %d",NSize(grp),grp.asize());
	}
	GetParentFrame()->SetMessageText(s);
}

void CCalcProbView::OnInitialUpdate()
{
	CCalcProbDoc* pDoc = GetDocument();
	m_mode = EM_Sel;
	pDoc->SetBkBitmap();
	SetScrollSizes(MM_TEXT,pDoc->ViewSize());
	CScrollView::OnInitialUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// CCalcProbView NẌ

BOOL CCalcProbView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CCalcProbView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* pInfo)
{
	pInfo->SetMaxPage(1);
}

void CCalcProbView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CCalcProbView NX̐ff

#ifdef _DEBUG
void CCalcProbView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CCalcProbView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CCalcProbDoc* CCalcProbView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCalcProbDoc)));
	return (CCalcProbDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCalcProbView NX̃bZ[W nh

void CCalcProbView::OnViewOption()
{
	CCalcProbDoc* pDoc = GetDocument();
	if (pDoc->DlgOption().DoModal() != IDOK) return;
	pDoc->SetBkBitmap();
	SetScrollSizes(MM_TEXT,pDoc->ViewSize());
	pDoc->ResetArc();
	pDoc->SetModify(true);
}

void CCalcProbView::OnUpdateEditMake(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mode == EM_Sel);
}

void CCalcProbView::OnUpdateEditMaken(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mode == EM_MakeNode);
}

void CCalcProbView::OnUpdateEditMakea(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mode == EM_MakeArc);
}

void CCalcProbView::OnUpdateEditMakec(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_mode == EM_MakeCom);
}

void CCalcProbView::OnEditMake()
{
	m_mode = EM_Sel;
	OnSetCursor(0,0,0);
}

void CCalcProbView::OnEditMaken()
{
	m_mode = EM_MakeNode;
	OnSetCursor(0,0,0);
}

void CCalcProbView::OnEditMakea()
{
	m_mode = EM_MakeArc;
	OnSetCursor(0,0,0);
}

void CCalcProbView::OnEditMakec() 
{
	m_mode = EM_MakeCom;
	OnSetCursor(0,0,0);
}

void CCalcProbView::OnEditMakenext()
{
	m_mode = EEditMode((int(m_mode) + 1) % 4);
	OnSetCursor(0,0,0);
}

void CCalcProbView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	CCalcProbDoc* pDoc = GetDocument();
	CScrollView::OnPrepareDC(pDC, pInfo);
	pDC->SetMapMode(MM_ISOTROPIC);
	CSize sz = pDoc->DocSize();
	pDC->SetWindowExt(sz);			// }̃TCY
	if (pDC->IsPrinting()) {
		sz = CSize(pDC->GetDeviceCaps(HORZRES),pDC->GetDeviceCaps(VERTRES));
	} else sz = pDoc->ViewSize();
	pDC->SetViewportExt(sz);		// \TCY
	if (!pInfo) {
		pDC->SetBkColor(GetSysColor(COLOR_WINDOW));
	}
}

BOOL CCalcProbView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	UINT	i = 0;
	switch (m_mode) {
	case EM_MakeNode: i = IDC_CURMAKEN; break;
	case EM_MakeArc:  i = IDC_CURMAKEA; break;
	case EM_MakeCom:  i = IDC_CURMAKEC; break;
	}
	if (i) SetCursor(AfxGetApp()->LoadCursor(i));
	else if (!pWnd) SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	else return CScrollView::OnSetCursor(pWnd, nHitTest, message);
	return TRUE;
}

void CCalcProbView::OnViewZoomup()
{
	CCalcProbDoc* pDoc = GetDocument();
	double	pre = pDoc->GetRate();
	pDoc->SetRate(pre * 1.25);
	CSize	sz = pDoc->ViewSize();
	if (sz.cx > 32767 || sz.cy > 32767) {
		pDoc->SetRate(pre);
		return;
	}
	SetScrollSizes(MM_TEXT,pDoc->ViewSize());
	Invalidate();
}

void CCalcProbView::OnViewZoomdown()
{
	CCalcProbDoc* pDoc = GetDocument();
	double	pre = pDoc->GetRate();
	pDoc->SetRate(pre * 0.8);
	CSize	sz = pDoc->ViewSize();
	if (sz.cx < 2 || sz.cy < 2) {
		pDoc->SetRate(pre);
		return;
	}
	SetScrollSizes(MM_TEXT,pDoc->ViewSize());
	Invalidate();
}

void CCalcProbView::OnViewZoomany()
{
	CCalcProbDoc* pDoc = GetDocument();
	double	pre = pDoc->GetRate();
	CString		s;
	s.Format("%g",pre);
	CDlgGetStr	dlg("{ݒ","{",s,this);
	if (dlg.DoModal() != IDOK) return;
	pDoc->SetRate(atof(dlg.m_val));
	CSize	sz = pDoc->ViewSize();
	if (sz.cx < 2 || sz.cx > 32767 || sz.cy < 2 || sz.cy > 32767) {
		pDoc->SetRate(pre);
		AfxMessageBox(IDW_INVALID_RATE);
		return;
	}
	SetScrollSizes(MM_TEXT,pDoc->ViewSize());
	Invalidate();
}

void CCalcProbView::OnSize(UINT nType, int cx, int cy) 
{
	CCalcProbDoc* pDoc = GetDocument();
	CScrollView::OnSize(nType, cx, cy);
	SetScrollSizes(MM_TEXT,pDoc->ViewSize());
}

CGraph::node_iterator CCalcProbView::GetNode(CPoint point)
{
	CCalcProbDoc*	pDoc = GetDocument();
	CGraph&		grp = pDoc->Graph();
	CGraph::node_iterator	nit;
	for (nit=grp.nbegin();nit!=grp.nend();++nit) {
		if (nit->Rect().PtInRect(point)) break;
	}
	return nit;
}

CGraph::arc_iterator CCalcProbView::GetArc(CPoint point)
{
	CCalcProbDoc*	pDoc = GetDocument();
	CGraph&		grp = pDoc->Graph();
	CGraph::arc_iterator	ait;
	for (ait=grp.abegin();ait!=grp.aend();++ait) {
		if (ait->Rect(ait.left()->m_pos,ait.right()->m_pos).PtInRect(point)) break;
	}
	return ait;
}

bool CCalcProbView::CheckMove(UINT& nFlags,CPoint& point)
{
	MSG msg;
	while (::GetMessage(&msg,0,0,0) >= 0) {
		if (msg.message == WM_MOUSEMOVE || msg.message == WM_LBUTTONUP) {
			nFlags = msg.wParam;
			point = CPoint((DWORD)msg.lParam);
			return msg.message == WM_MOUSEMOVE;
		}
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
	return false;
}

void CCalcProbView::OnMouseClick(UINT nFlags, CPoint point0)
{
	CCalcProbDoc* pDoc = GetDocument();
	CGraph&					grp = pDoc->Graph();
	CSelNode&				selN = pDoc->SelNode();
	CSelArc&				selA = pDoc->SelArc();
	CSelNode::iterator		sit;
	CGraph::node_iterator	nit,nit2;
	UINT					flg;
	CPoint					point,pre,pt;
	CClientDC				dc(this);

	OnPrepareDC(&dc);
	point = point0;
	dc.DPtoLP(&point);
	nit = GetNode(point); // NbNʒũm[h𒲂ׂ;
	if (nit == grp.nend()) {	// m[hȂ
		selN.clear();
		CGraph::arc_iterator	ait = GetArc(point);	// NbNʒũA[N𒲂ׂ
		if (ait != grp.aend()) {			// A[N
			if (selA.find(ait) == selA.end()) {		// IĂȂ
				if (!(nFlags & MK_SHIFT))
					selA.clear();
				selA.insert(ait);
				Invalidate();
			} else if (nFlags & MK_SHIFT) {
				selN.erase(nit);
				Invalidate();
			}
			return;
		}
		selA.clear();
		if (m_mode == EM_MakeNode) {	// VKm[h쐬
			pDoc->Clone(CCalcProbDoc::UndoSize);
			nit = grp.add_node(CNode(point,""));
			pDoc->SetModify(true);
		} else if (m_mode == EM_MakeCom) {	//Rg쐬
			CDlgGetStr	dlg("Rg","Rg","",this);
			ReleaseCapture();
			if (dlg.DoModal() != IDOK) return;
			pDoc->Clone(CCalcProbDoc::UndoSize);
			nit = grp.add_node(CNode(point,dlg.m_val));
			nit->m_type = CNode::Comment;
			pDoc->SetModify(true);
			m_mode = EM_Sel;
			return;
		} else if (m_mode == EM_Sel) {	// `\
			CRect     r(point,CSize(0,0));
			int pr = dc.SetROP2(R2_NOT);
			DrawRect(&dc,r);
			while (CheckMove(flg,pt)) {
				dc.DPtoLP(&pt);
				DrawRect(&dc,r);
				r.BottomRight() = pt;
				DrawRect(&dc,r);
			}
			DrawRect(&dc,r);
			dc.SetROP2(pr);
			r.NormalizeRect();
			for (nit=grp.nbegin();nit!=grp.nend();++nit)
				if (r.PtInRect(nit->m_pos)) selN.insert(nit);
			Invalidate();
			return;
		} else {
			return;
		}
	}
	selA.clear();
	if (selN.find(nit) == selN.end()) {
		if (!(nFlags & MK_SHIFT))
			selN.clear();
		selN.insert(nit);
		Invalidate();
	} else if (nFlags & MK_SHIFT) {
		selN.erase(nit);
		Invalidate();
	}
	if (m_mode != EM_MakeArc) {		// hbOړ
		if (CheckMove(flg,pt)) {
			pDoc->Clone(CCalcProbDoc::UndoSize);
			pDoc->SetModifiedFlag();
			pre = point;
			do {
				dc.DPtoLP(&pt);
				for (sit=selN.begin();sit!=selN.end();++sit)
					(*sit)->m_pos += pt - pre;
				pre = pt;
				Invalidate();
			} while (CheckMove(flg,pt));
		}
		return;
	}
	// A[N̍쐬
	pDoc->Clone(CCalcProbDoc::UndoSize);
	point = nit->m_pos;
	nit2 = grp.nend();
	int pr = dc.SetROP2(R2_NOT);
	DrawLine(&dc,point,pre = point);
	while (CheckMove(flg,pt)) {
		dc.DPtoLP(&pt);
		nit2 = GetNode(pt);
		if (nit2 != grp.nend()
			&& nit2->m_type != CNode::Comment) pt = nit2->m_pos;
		DrawLine(&dc,point,pre);
		DrawLine(&dc,point,pre = pt);
	}
	DrawLine(&dc,point,pre);
	dc.SetROP2(pr);
	if (nit2 == grp.nend() || nit2->m_type == CNode::Comment) return;
	if (nit == nit2 || grp.connect_arc(nit,nit2) != grp.aend()) {
//		AfxMessageBox("ɃA[N܂");
		return;
	}
	selN.clear();
	selA.clear();
	pair<CGraph::arc_iterator,bool> pit
		= grp.add_arc(CArc(0),nit,nit2);
	if (pit.second) {
		CGraph::arc_iterator ait = pit.first;
		ait->m_str = pDoc->DlgOption().m_prob;
		if (sscanf(ait->m_str,"%lf",&ait->m_prob) == 1)
			ait->m_str = "";
		selA.insert(ait);
	}
	pDoc->SetModify(true);
}


void CCalcProbView::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (!GetCapture()) {
		SetCapture();
		OnMouseClick(nFlags,point);
		ReleaseCapture();
	}
}

void CCalcProbView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CView::OnLButtonDblClk(nFlags, point);
	CCalcProbDoc* pDoc = GetDocument();
	if (pDoc->SelNode().size() == 1) {
		CDlgInfoNode	dlg;
		CNode&			nd = **pDoc->SelNode().begin();
		if (nd.m_type == CNode::Comment) {
			CDlgGetStr	dlg2("Rg","Rg",nd.m_name,this);
			if (dlg2.DoModal() != IDOK) return;
			nd.m_name = dlg2.m_val;
			pDoc->SetModify(true);
			return;
		}
		dlg.m_bFirst = nd.m_type == CNode::Start;
		dlg.m_name = nd.m_name;
		dlg.m_prob.Format("%g",nd.m_val);
		dlg.m_ave = nd.m_ave;
		if (dlg.DoModal() != IDOK) return;
		pDoc->Clone(CCalcProbDoc::UndoSize);
		nd.m_name = dlg.m_name;
		if (dlg.m_bFirst != 0) {
			CGraph&					grp = pDoc->Graph();
			CGraph::node_iterator	nit;
			for (nit=grp.nbegin();nit!=grp.nend();++nit) {
				if (nit->IsNode()) nit->m_type = CNode::Node;
			}
			nd.m_type = CNode::Start;
		} else nd.m_type = CNode::Node;
		pDoc->SetModify(true);
	} else if (pDoc->SelArc().size() == 1) {
		CDlgInfoArc		dlg;
		CArc&			ac = **pDoc->SelArc().begin();
		dlg.m_color.m_color = ac.m_color;
		if (ac.m_str.IsEmpty()) dlg.m_prob.Format("%g",ac.m_prob);
		else dlg.m_prob = ac.m_str;
		if (dlg.DoModal() != IDOK) return;
		pDoc->Clone(CCalcProbDoc::UndoSize);
		ac.m_color = dlg.m_color.m_color;
		ac.m_str = "";
		if (sscanf(dlg.m_prob,"%lf",&ac.m_prob) != 1)
			ac.m_prob = pDoc->DlgOption().m_dict[ac.m_str = dlg.m_prob];
		pDoc->SetModify(true);
	}
}

BOOL CCalcProbView::OnEraseBkgnd(CDC* pDC)
{
//	return TRUE;
	return CScrollView::OnEraseBkgnd(pDC);
}

void CCalcProbView::OnEditCut() 
{
	CCalcProbDoc* pDoc = GetDocument();
	CGraph&		grp = pDoc->Graph();
	if (!pDoc->SelNode().empty()) {
		CSelNode::iterator	it;
		pDoc->Clone(CCalcProbDoc::UndoSize);
		for (it=pDoc->SelNode().begin();it!=pDoc->SelNode().end();++it)
			grp.del_node(*it);
		pDoc->SelNode().clear();
		pDoc->SetModify(true);
	} else if (!pDoc->SelArc().empty()) {
		CSelArc::iterator	it;
		pDoc->Clone(CCalcProbDoc::UndoSize);
		for (it=pDoc->SelArc().begin();it!=pDoc->SelArc().end();++it)
			grp.del_arc(*it);
		pDoc->SelArc().clear();
		pDoc->SetModify(true);
	}
}

void CCalcProbView::OnEditSelectAll() 
{
	CCalcProbDoc* pDoc = GetDocument();
	CGraph&		grp = pDoc->Graph();
	CGraph::node_iterator	nit;
	pDoc->SelNode().clear();
	pDoc->SelArc().clear();
	for (nit=grp.nbegin();nit!=grp.nend();++nit)
		pDoc->SelNode().insert(nit);
	Invalidate();
}

void CCalcProbView::OnHelp() 
{
	char buf[512],*p;
	DWORD	d;
	HKEY	h;
	if (RegOpenKeyEx(HKEY_CLASSES_ROOT,
		"CalcPr.Document\\shell\\open\\command",0,KEY_READ,&h) != ERROR_SUCCESS)
		return;
	RegQueryValueEx(h,0,0,0,(LPBYTE)buf,&d);// != ERROR_SUCCESS) return;
	RegCloseKey(h);
	p = strstr(buf,".exe \"%1\"");
	if (!p) return;
	strcpy(p,".chm");
	ShellExecute(0,"open",buf,0,0,SW_SHOW);
}
