// DlgOption.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CalcProb.h"
#include "DlgOption.h"
#include <vector>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgOption _CAO


CDlgOption::CDlgOption(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOption::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgOption)
	m_bkPict = _T("");
	m_height = 0;
	m_width = 0;
	m_bShowArc = TRUE;
	m_bShowNode = TRUE;
	m_var = _T("");
	m_iter = 1000;
	m_prob = _T("0.1");
	//}}AFX_DATA_INIT
	Reset();
}

void CDlgOption::Reset()
{
	m_bkPict = "";
	m_height = 400;
	m_width = 600;
	m_bShowArc = TRUE;
	m_bShowNode = TRUE;
	m_var = "";
	m_iter = 1000;
	m_prob = "0.1";
}

void CDlgOption::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOption)
	DDX_Text(pDX, IDC_OPT_BKPICT, m_bkPict);
	DDX_Text(pDX, IDC_OPT_HEIGHT, m_height);
	DDX_Text(pDX, IDC_OPT_WIDTH, m_width);
	DDX_Check(pDX, IDC_SHOW_ARC, m_bShowArc);
	DDX_Check(pDX, IDC_SHOW_NODE, m_bShowNode);
	DDX_Text(pDX, IDC_VAR, m_var);
	DDX_Text(pDX, IDC_ITER, m_iter);
	DDV_MinMaxInt(pDX, m_iter, 1, 1000000);
	DDX_Text(pDX, IDC_OPT_PROB, m_prob);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgOption, CDialog)
	//{{AFX_MSG_MAP(CDlgOption)
	ON_BN_CLICKED(IDC_OPT_BKREF, OnOptBkref)
	ON_BN_CLICKED(IDC_BTN_FIT, OnBtnFit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOption bZ[W nh

void CDlgOption::OnOptBkref() 
{
	CFileDialog	dlg(TRUE,"bmp",0,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Bitmap ̧(*.bmp)|*.bmp|",this);
	if (dlg.DoModal() != IDOK) return;
	m_bkPict = dlg.GetPathName();
	UpdateData(FALSE);
}

void CDlgOption::Serialize(CArchive& ar) 
{
	if (ar.IsStoring()) {
		ar << m_bkPict << m_height << m_width << m_var
			<< m_prob << m_bShowArc << m_bShowNode;
	} else {
		ar >> m_bkPict >> m_height >> m_width >> m_var
			>> m_prob >> m_bShowArc >> m_bShowNode;
	}
}

void CDlgOption::OnBtnFit() 
{
	CWnd*	p = GetParent();
	CRect	r;
	if (!p) return;
	CString	s;
	p->GetClientRect(&r);
	s.Format("%d",_MAX(100,r.Width()-4));
	GetDlgItem(IDC_OPT_WIDTH)->SetWindowText(s);
	s.Format("%d",_MAX(100,r.Height()-47));
	GetDlgItem(IDC_OPT_HEIGHT)->SetWindowText(s);
}

bool CDlgOption::SetDict() 
{
	if (!UpdateData()) return false;
	double	d;
	char	buf[80];
	const char*	p = m_var;
	int		n, k = 0;
	m_dict.clear();
	while ((n = sscanf(p += k,"%s %lf%n",buf,&d,&k)) == 2) {
		if (d < 0. || d > 1.) return false;
		m_dict[buf] = d;
	}
	return n != 1;
}

void CDlgOption::OnOK() 
{
	if (!SetDict()) {
		AfxMessageBox("ϐ̐ݒ肪܂");
		GetDlgItem(IDC_VAR)->SetFocus();
		return;
	}
	CDialog::OnOK();
}
