// data.cpp

#include "stdafx.h"
#include "data.h"

CRect CNode::Rect()
{
	if (m_type != Comment) {
		CSize sz(10,10);
		return CRect(m_pos-sz,m_pos+sz);
	}
	return CRect(m_pos,m_pos + CSize(m_name.GetLength()*8+4,18));
}

void CNode::Draw(CDC* pDC,bool b)
{
	int offs = 0;
	if (IsNode()) {
		CRect r = Rect();
		r.InflateRect(-2,-2);
		CBrush	br(RGB(0,0,0)),*p;
		p = m_type == Start ? pDC->SelectObject(&br) : 0;
		pDC->Ellipse(r);
		if (p) pDC->SelectObject(p);
		offs = 15;
	}
	if (b) {
		CString s;
		if (m_type == Comment) s.Format("%s",(const char*)m_name);
		else s.Format("%s(%.2f)",(const char*)m_name,m_val);
		pDC->TextOut(m_pos.x+offs,m_pos.y,s);
	}
}

void CNode::DrawSel(CDC* pDC)
{
	CBrush* pOldb = (CBrush*)pDC->SelectStockObject(HOLLOW_BRUSH);
	pDC->Rectangle(Rect());
	pDC->SelectObject(pOldb);
}

void CNode::Serialize(CArchive& ar,int ver)
{
	if (ar.IsStoring()) ar << m_type << m_pos << m_name;
	else {
		int	i;
		ar >> i >> m_pos >> m_name;
		m_type = CNode::EType(i);
	}
}

CPoint CArc::Center(const CPoint& ptl,const CPoint& ptr)
{
	return CPoint((ptl.x+ptr.x)/2-(ptl.x-ptr.x)/10,
					(ptl.y+ptr.y)/2-(ptl.y-ptr.y)/10);
}

CRect CArc::Rect(const CPoint& ptl,const CPoint& ptr)
{
	CSize sz(30,30);
	CPoint	pt = Center(ptl,ptr);
	return CRect(pt-sz,pt+sz);
}

void CArc::Draw(CDC* pDC,const CPoint& ptl,const CPoint& ptr,bool b)
{
	CPen	pen(PS_SOLID,0,m_color),
		*pOldp = pDC->SelectObject(&pen);
	DrawArrow(pDC,ptl.x,ptl.y,ptr.x,ptr.y,15);
	pDC->SelectObject(pOldp);
	if (b) {
		CString s;
		if (m_str.IsEmpty())
			s.Format("%.2f",m_prob);
		else s = m_str;
		CPoint pt = Center(ptl,ptr);
		pDC->TextOut(pt.x,pt.y,s);
	}
}

void CArc::DrawSel(CDC* pDC,const CPoint& ptl,const CPoint& ptr)
{
	CBrush* pOldb = (CBrush*)pDC->SelectStockObject(HOLLOW_BRUSH);
	pDC->Rectangle(Rect(ptl,ptr));
	pDC->SelectObject(pOldb);
}

void CArc::Serialize(CArchive& ar,int ver)
{
	if (ar.IsStoring()) ar << m_prob << m_str << m_color;
	else ar >> m_prob >> m_str >> m_color;
}
